<?php
@session_start(); //Запускаем сессии
// Определение файлов и путей
defined("ROOT_PATH") || define("ROOT_PATH", dirname(__FILE__));
defined("FOLDER") || define("FOLDER", realpath(ROOT_PATH . "/../stata"));
defined("FOLDER_BLACK") || define("FOLDER_BLACK", realpath(ROOT_PATH . "/IP"));
defined("STATE_PATCH") || define("STATE_PATCH", realpath(ROOT_PATH . "/log"));
defined("FILE_CACHE") || define("FILE_CACHE", (STATE_PATCH . "/cache.html"));
defined("FILE_BLACKLIST") || define("FILE_BLACKLIST", (FOLDER_BLACK . "/blacklist.dat"));
defined("FILE_USER") || define("FILE_USER", (STATE_PATCH . '/use_' . date("Y-m-d") . '.php'));
defined("FILE_BOT") || define("FILE_BOT", (STATE_PATCH . '/bot_' . date("Y-m-d") . '.php'));
defined("FILE_COUNTER") || define("FILE_COUNTER", (STATE_PATCH . '/counter_' . date("Y-m-d") . '.php'));
$ip = $_SERVER['REMOTE_ADDR'];
// Костыль для криворуких админов
if ($_SERVER['REMOTE_ADDR'] == '127.0.0.1') {
    $ip = $_SERVER["HTTP_X_REAL_IP"];
}
//
// Проверка домена
$hostname         = gethostbyaddr($ip);
$referer          = $_SERVER['HTTP_REFERER'];
$request_url      = $_SERVER['REQUEST_URI'];
$http_host        = $_SERVER['HTTP_HOST'];
require_once(ROOT_PATH . "/config.php");
?>
<?php
class AuthClassS{
    private $_login = "admin"; //Устанавливаем логин
    private $_password = "admin"; //Устанавливаем пароль
    public function isAuth(){
        if (isset($_SESSION["is_auth"])) { //Если сессия существует
            return $_SESSION["is_auth"]; //Возвращаем значение переменной сессии is_auth (хранит true если авторизован, false если не авторизован)
        } else
            return false; //Пользователь не авторизован, т.к. переменная is_auth не создана
    }
    public function auth($login, $passwors){
        if ($login == $this->_login && $passwors == $this->_password) { //Если логин и пароль введены правильно
            $_SESSION["is_auth"] = true; //Делаем пользователя авторизованным
            $_SESSION["login"]   = $login; //Записываем в сессию логин пользователя
            exit("<meta http-equiv='refresh' content='0; url= $_SERVER[PHP_SELF]?hi'>");
            return true;
        } else {
            //Логин и пароль не подошел
            $_SESSION["is_auth"] = false;
            return false;
        }
    }
    public function getLogin(){
        if ($this->isAuth()) { //Если пользователь авторизован
            return $_SESSION["login"]; //Возвращаем логин, который записан в сессию
        }
    }
    public function out(){
        $_SESSION = array(); //Очищаем сессию
        session_destroy(); //Уничтожаем
    }
}
$auth = new AuthClassS();
if (isset($_POST["login"]) && isset($_POST["password"])) { //Если логин и пароль были отправлены
    if (!$auth->auth($_POST["login"], $_POST["password"])) { //Если логин и пароль введен не правильно
        $messerr = '<p class="_mess_error">Логин или пароль введены не правильно!</p>';
    }
}
if (isset($_GET["is_exit"])) { //Если нажата кнопка выхода
    if ($_GET["is_exit"] == 1) {
        $auth->out(); //Выходим
        header("Location: ?Bye!"); //Редирект после выхода
    }
}
?>
<?php
// Функция присваивания значка страны
function getCOUNTRY($country_detect){
    $citycountry = array(
        ' <sub><img title="Россия" src=img/flag_ru.png width="18"></sub>' => 'RU',
        ' <sub><img title="Австралия" src=img/flag-au.png width="18"></sub>' => 'AU',
        ' <sub><img title="Украина" src=img/ua.png width="18"></sub>' => 'UA',
        ' <sub><img title="Американские Виргинские острова" src=img/Virgin_Islands.png width="18"></sub>' => 'VI',
        ' <sub><img title="США" src=img/USA.png width="18"></sub>' => 'US',
        ' <sub><img title="Белоруссия" src=img/belarus_small.png width="18"></sub>' => 'BY',
        ' <sub><img title="Чехия" src=img/czec_republic.png width="18"></sub>' => 'CZ',
        ' <sub><img title="Британские Виргинские острова" src=img/British-Virgin-Islands.png width="18"></sub>' => 'VG',
        ' <sub><img title="Нидерланды (Голландия)" src=img/netherlands_small.png width="18"></sub>' => 'NL',
        ' <sub><img title="Франция" src=img/france.png width="18"></sub>' => 'FR',
        ' <sub><img title="Германия" src=img/germany.png width="18"></sub>' => 'DE',
        ' <sub><img title="Казахстан" src=img/kazakhstan_small.png width="18"></sub>' => 'KZ',
        ' <sub><img title="Австрия" src=img/austria_small.png width="18"></sub>' => 'AT',
        ' <sub><img title="Италия" src=img/ITA.png width="18"></sub>' => 'IT',
        ' <sub><img title="Китай" src=img/china_small.png width="18"></sub>' => 'CN',
        ' <sub><img title="Литва" src=img/LTU.png width="18"></sub>' => 'LT',
        ' <sub><img title="Испания, Канары" src=img/ESP.png width="18"></sub>' => 'ES',
        ' <sub><img title="Турция" src=img/turkey_small.png width="18"></sub>' => 'TR',
        ' <sub><img title="Шри-Ланка (Цейлон)" src=img/sri_lanka_small.png width="18"></sub>' => 'LK',
        ' <sub><img title="Тайвань" src=img/taiwan_small.png width="18"></sub>' => 'TW',
        ' <sub><img title="Азербайджан" src=img/azerbaijan_small.png width="18"></sub>' => 'AZ',
        ' <sub><img title="Евросоюз" src=img/european-union.png width="18"></sub>' => 'EU',
        ' <sub><img title="Канада" src=img/canada_small.png width="18"></sub>' => 'CA',
        ' <sub><img title="Сербия" src=img/Serbia1.png width="18"></sub>' => 'RS',
        ' <sub><img title="Армения" src=img/ARM.png width="18"></sub>' => 'AM',
        ' <sub><img title="Португалия" src=img/portugal.png width="18"></sub>' => 'PT',
        ' <sub><img title="ЮАР" src=img/south_africa_small.png width="18"></sub>' => 'ZA',
        ' <sub><img title="Великобритания" src=img/GB.png width="18"></sub>' => 'GB',
        ' <sub><img title="Израиль" src=img/ISR.png width="18"></sub>' => 'IL',
        ' <sub><img title="Румыния" src=img/romania_small.png width="18"></sub>' => 'RO',
        ' <sub><img title="Польша" src=img/poland_small.png width="18"></sub>' => 'PL',
        ' <sub><img title="Ангола" src=img/angola_flag.png width="18"></sub>' => 'AO',
        ' <sub><img title="Индия" src=img/india.png width="18"></sub>' => 'IN'
        
        
    );
    foreach ($citycountry as $os => $pattern) {
        if (mb_ereg($pattern, $country_detect)) {
            return $os;
        }
    }
    return $country_detect;
}
?>
<?php
// Функция определения браузера и присвоение значка
function getBROWSER($user_agent_browser){
    // Создадим список операционных систем в виде элементов массива
    $user_browser = array(
        '<div class="prosmr" title="Bеб-браузер и программный пакет для работы в Интернете, выпускаемый компанией Opera Software. Разработан в 1994 году группой исследователей из норвежской компании Telenor"><sub><img src=img/0pera.png width="18"></sub>opera</div>' => '(Opera)|(Presto)|(Opera Mobi)|(Opera Mini)|(OPR)|(Edition Campaign )',
        '<div class="prosmr" title="«огненная лиса», но на самом деле это малая панда) — свободный браузер, входящий в набор программ Mozilla Application Suite, разработкой и распространением которого занимается Mozilla Corporation. Третий по популярности браузер в мире и первый среди свободного ПО "><sub><img src=img/firefox.png width="18"></sub>firefox</div>' => 'Firefox',
        '<div class="prosmr" title="Браузер Google Chrome – это браузер, сочетающий в себе минималистичный дизайн и сложные технологии."><sub><img src=img/chrom.png width="18"></sub>chrome</div>' => 'Chrome',
        '<div class="prosmr" title="Браузер, разработанный корпорацией Apple и входящий в состав OS X и iOS. Стабильно занимает четвёртое место по числу пользователей"><sub><img src=img/Apple_Safari.png width="18"></sub>safari</div>' => 'Safari',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 6</div>' => 'MSIE 6.0',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 7</div>' => 'MSIE 7.0',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 8</div>' => 'MSIE 8.0',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 9</div>' => 'MSIE 9.0',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 10</div>' => 'MSIE 10.0',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 11</div>' => 'MSIE 11.0',
        '<div class="prosmr" title="Программа для скачивания браузера."><sub><img src=img/msie.png width="18"></sub>Internet Explorer 12</div>' => 'MSIE 12.0',
        '<div class="prosmr" title="Ядро отображения страниц (layout engine) для Windows-версии Microsoft Internet Explorer."><sub><img src=img/msie.png width="18"></sub>Trident/7</div>' => 'Trident/7',
        '<div class="prosmr" title="Бесплатный (freeware) браузер на трёх движках: Microsoft Trident, Webkit, Gecko."><sub><img src=img/avant-browser-icon.png width="18"></sub>Avant Browser</div>' => 'Avant Browser',
        '<div class="prosmr" title="Браузер «Амиго» – это не только быстрый и безопасный браузер, но и приложение для социальных сетей. Благодаря ему, вы сразу будете в курсе новостей ваших друзей, сможете обмениваться личными сообщениями, слушать музыку, делиться ссылками, менять свой статус, и все это не переходя на страницу социальной сети."><sub><img src=img/amigo_logo.png width="18"></sub>«Амиго»</div>' => 'MRCHROME SOC',
        '<div class="prosmr" title="Яндекс.Браузер — это простая, удобная и быстрая программа для работы в интернете. Браузер от Яндекса существенно ускоряет загрузку страниц ..."><sub><img src=img/brauz.yandex.png width="18"></sub>Yandex Browser</div>' => 'YaBrowser'
        
    );
    foreach ($user_browser as $os => $pattern) {
        if (mb_ereg($pattern, $user_agent_browser)) {
            return $os;
        }
    }
    return 'Unknown';
}
?>
<?php
// Функция определения OS
function getOS($userAgent){
    // Создадим список операционных систем в виде элементов массива
    $oses = array(
        '<sub><img title="" src=img/Windows_Phone.png width="18"></sub>Windows Phone' => 'Windows Phone',
        '<sub><img title="Android 4.2.1" src=img/Android.png width="18"></sub>Android 4.0' => 'Android 4.0',
        '<sub><img title="Android 4.1.9" src=img/Android.png width="18"></sub>Android 4.1' => 'Android 4.1',
        '<sub><img title="Android 4.2.0" src=img/Android.png width="18"></sub>Android 4.2' => 'Android 4.2',
        '<sub><img title="Android 4.2.0" src=img/Android.png width="18"></sub>Android 4.3' => 'Android 4.3',
        '<sub><img title="Android 4.2.0" src=img/Android.png width="18"></sub>Android 4.4' => 'Android 4.4',
        '<sub><img title="Android 4.2.0" src=img/Android.png width="18"></sub>Android 4.5' => 'Android 4.5',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 0.5' => 'Android 0.5',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 1.5' => 'Android 1.5',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 1.6' => 'Android 1.6',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.0' => 'Android 2.0',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.1' => 'Android 2.1',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.2' => 'Android 2.2',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.3' => 'Android 2.3',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.4' => 'Android 2.4',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.5' => 'Android 2.5',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.6' => 'Android 2.6',
        '<sub><img title="Android 4.2.2" src=img/Android.png width="18"></sub>Android 2.7' => 'Android 2.7',
        '<sub><img title="Android" src=img/Android.png width="18"></sub>Android' => 'Android',
        
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone IOS 7' => '(iPhone; U; CPU iPhone OS 7_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone IOS 6' => '(iPhone; U; CPU iPhone OS 6_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone IOS 5' => '(iPhone; U; CPU iPhone OS 5_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone IOS 4' => '(iPhone; U; CPU iPhone OS 4)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone IOS 3' => '(iPhone; U; CPU iPhone OS 3_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone IOS 2' => '(iPhone; U; CPU iPhone OS 2_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPhone' => '(iPhone)',
        
        
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad IOS 7' => '(iPad; U; CPU iPhone OS 7_)|(iPad; CPU OS 7_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad IOS 6' => '(iPad; U; CPU iPhone OS 6_)|(iPad; CPU OS 6_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad IOS 5' => '(iPad; U; CPU iPhone OS 5_)|(iPad; CPU OS 5_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad IOS 4' => '(iPad; U; CPU iPhone OS 4_)|(iPad; CPU OS 4_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad IOS 3' => '(iPad; U; CPU iPhone OS 3_)|(iPad; CPU OS 3_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad IOS 2' => '(iPad; U; CPU iPhone OS 2_)|(iPad; CPU OS 2_)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPad' => '(iPad)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>iPod' => '(iPod)',
        '<sub><img title="Операционная система для сотовых телефонов, смартфонов и коммуникаторов, разрабатываемая консорциумом Symbian, основанным в июне 1998 года компаниями: Nokia, Psion, Ericsson и Motorola." src=http://soft-angel.ru/stata_upgrade/img/Symbian.png width="18"></sub>Symbian' => 'Symbian',
        '<sub><img title="Профиль для мобильного устройства с информационными функциями (платформа J2ME)." src=img/f.png width="18"></sub>J2ME/MIDP' => 'J2ME/MIDP',
        '<sub><img src=img/Bada.png width="18"></sub>Bada' => 'Bada',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows 3.11' => 'Win16',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows 95' => '(Windows 95)|(Win95)|(Windows_95)', // Используем регулярное выражение
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows 98' => '(Windows 98)|(Win98)',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows 2000' => '(Windows NT 5.0)|(Windows 2000)',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows XP' => '(Windows NT 5.1)|(Windows XP)',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows 2003' => '(Windows NT 5.2)',
        '<sub><img title="" src=img/windowsvista.png width="18"></sub>Windows Vista' => '(Windows NT 6.0)|(Windows Vista)',
        '<sub><img title="" src=img/Windows7.png width="18"></sub>Windows 7' => '(Windows NT 6.1)|(Windows 7)',
        '<sub><img title="" src=img/Windows8.png width="18"></sub>Windows 8' => '(Windows NT 6.2)|(Windows NT 6.3)|(Windows 8)',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows' => '(Windows NT 4.0)|(WinNT4.0)|(WinNT)|(Windows NT)',
        '<sub><img title="" src=img/windows.png width="18"></sub>Windows ME' => 'Windows ME',
        '<sub><img title="" src=img/freebsd.png width="18"></sub>Open BSD' => 'OpenBSD',
        '<sub><img title="" src=img/bsd.png width="18"></sub>Sun OS' => 'SunOS',
        '<sub><img title="" src=img/linux.png width="18"></sub>Linux' => '(Linux)|(X11)',
        '<sub><img title="" src=img/apple_64.png width="18"></sub>Macintosh' => '(Mac_PowerPC)|(Macintosh)',
        '<sub><img title="" src=img/qnx.png width="18"></sub>QNX' => 'QNX',
        '<sub><img title="" src=img/os_beos.png width="18"></sub>BeOS' => 'BeOS',
        '<sub><img title="" src=img/os2.png width="18"></sub>OS/2' => 'OS/2'
    );
    foreach ($oses as $os => $pattern) {
        if (mb_ereg($pattern, $userAgent)) {
            return $os;
        }
    }
    return 'Unknown';
}
?>
<?php
function getOTHBOTdomain($domain){
    // Функция определения и присвоения иконок роботам по домену
    $domain_othbot = array(
        '<div class="prosmr" title="Робот хостинга Majordomo"><sub><img src=img/majordomo.png width="18"></sub>&nbsp;Majordomo&nbsp;</div>' => 'majordomo.ru',
        '<div class="prosmr" title="Робот хостинга"><sub><img src=img/f.png width="18"></sub>&nbsp;Хостинг-робот&nbsp;</div>' => '(masterhost.ru)|(eserver-ru.com)|(datapoint.ru)|(rbinfo.ru)|(redstation.co.uk)|(os3.nl)|(globatel.ru)|(kundenserver.de)|(itrack.ru)|(page-weight.ru)|(hc.ru)|(masterhost.ru)|(ukraine.com.ua)|(peterhost.ru)|(domain.by)|(webservis.ru)|(jino.ru)|(infobox.ru)|(mchost.ru)|(zenon.net)|(timeweb.ru)|(sweb.ru)|(hoster.by)|(umi.ru)|(host.ru)|(host.net)|(hostland.ru)|(valuehost.ru)|(ho.ua)|(netfox.ru)|(hosting)|(komtet.ru)|(centre.ru)|(rusonyx.ru)|(netangels.ru)|(webstolica.ru)|(nic.ua)|(hoster.ru)|(server)|(ruweb.net)',
        '<div class="prosmr" title="Система купли/продажи ссылок для раскрутки сайтов и заработка в интернете."><sub><img src=img/sape.png width="18"></sub>&nbsp;Sape&nbsp;</div>' => 'ws.controlstyle.ru',
        '<div class="prosmr" title="Мощьный сервис по статистике и аналитике сайтов"><sub><img src=img/pingdom.png width="18"></sub>&nbsp;Pingdom&nbsp;</div>' => 'pingdom.com',
        '<div class="prosmr" title="Cервис анализа сайтов для вебмастеров, оптимизаторов и копирайтеров."><sub><img src=img/pr-cy_30.png width="18"></sub>&nbsp;PR-CY&nbsp;</div>' => 'pr-cy.ru',
        '<div class="prosmr" title="Сканирование на вирусы по базам данных всех ведущих мировых вендоров"><sub><img src=img/loading.gif width="18"></sub>&nbsp;antivirus-alarm.ru&nbsp;</div>' => 'antivirus-alarm.ru',
        '<div class="prosmr" title="Мего сервис короче)"><sub><img src=img/2ip_favicon.png width="18"></sub>&nbsp;2ip.ru&nbsp;</div>' => '2ip.ru',
        '<div class="prosmr" title="Робот делающий скрины сайта"><sub><img src=img/Site-Shot.png width="18"></sub>&nbsp;Site-Shot&nbsp;</div>' => 'your-server.de',
        '<sub><img title="Сервис блеклиста" src=img/f.png width="18"></sub>&nbsp;AhrefsBot&nbsp;' => 'softlayer.com'
    );
    foreach ($domain_othbot as $os => $pattern) {
        if (mb_ereg($pattern, $domain)) {
            return $os;
        }
    }
    return 'Unknown';
}
?>
<?php
// Функция определения и присвоения иконок не поисковым роботам по user agent
function getOTHBOT($user_agent_bots2){
    $user_othbot = array(
        '<div class="prosmr"  title="Робот соц сети Вконтакте"><sub><img src=img/vk_24.png width="18"></sub>&nbsp;vkShare&nbsp;</div> ' => 'vkShare',
        '<div class="prosmr"  title="Аналитика, которая расскажет всё о вашем сайте"><sub><img src=img/openstat.ru.png width="18"></sub>&nbsp;Openstat&nbsp;</div> ' => 'openstat.ru',
        '<div class="prosmr"  title="Робот соц сети Twitter"><sub><img src=img/twitter_32.png width="18"></sub>&nbsp;Twitterbot&nbsp;</div> ' => 'Twitterbot',
        '<div class="prosmr"  title="Валидатор HTML"><sub><img src=img/w3c.gif width="18"></sub>&nbsp;W3C Validator&nbsp;</div> ' => 'W3C_Validator',
        '<div class="prosmr"  title="Валидатор CSS"><sub><img src=img/w3c.gif width="18"></sub>&nbsp;W3C CSS Validator JFouffa&nbsp;</div> ' => 'W3C_CSS_Validator_JFouffa',
        '<div class="prosmr"  title="Возможно спамер"><sub><img src=img/f.png width="18"></sub>&nbsp;FunWebProducts&nbsp;</div> ' => 'FunWebProducts',
        '<sub><img src=img/f.png width="18"></sub>&nbsp;BLEXBot&nbsp;' => 'BLEXBot',
        '<sub><img src=img/f.png width="18"></sub>&nbsp;Ezooms&nbsp;' => 'Ezooms',
        '<div class="prosmr"  title="Робот поисковой стстемы по доменам"><sub><img src=img/MJ12bot.png width="18"></sub> MJ12bot </div>' => 'MJ12bot',
        '<sub><img title="Сервис блеклиста" src=img/f.png width="18"></sub>&nbsp;AhrefsBot&nbsp;' => 'AhrefsBot',
        '<sub><img title="Программа для взлома!!!" src=img/warning.gif width="18"></sub> <strong><span style="background-color: #ff0000;">&nbsp;!!!Paros!!!&nbsp;</span></strong> ' => 'Paros',
        '<sub><img title="Ворует страницы!!!" src=img/f.png width="18"></sub>&nbsp;!!!URLGrabber!!!&nbsp;' => 'URLGrabber'
    );
    foreach ($user_othbot as $os => $pattern) {
        if (mb_ereg($pattern, $user_agent_bots2)) {
            return $os;
        }
    }
    return false;
}
?>

<?php
// Функция определения и присвоения иконок роботам по user agent
function getBOT($user_agent_bots,$q_mod = false){
    $user_bot = array(
		array(
            'Yandex',
			'YandexBot',
            '<div class="prosmr" title="Основной индексирующий робот Яндекса"><sub><img src=img/icon_yandex.png width="18"></sub> YandexBot</div> ',
        ),
		array(
            '(bingbot)|(msn.com)|(msnbot)',
			'Bing',
            '<div class="prosmr" title="Основной индексирующий робот."><sub><img src=img/bing.png width="18"></sub> Bingbot</div> ',
        ),
		array(
            'YandexImages',
			'Yandex',
            '<sub><img src=img/images_yandex.png width="18"></sub> YandexImages ',
        ),
		array(
            'YaDirectFetcher',
			'Yandex',
            '<div class="prosmr" title="Pобот Яндекс.Директа, интерпретирует robots.txt особым образом"><sub><img src=img/icon_yandex.png width="18"></sub> YaDirectFetcher </div>',
        ),
		array(
            'YandexCatalog',
			'Yandex',
            '<div class="prosmr" title="«простукивалка» Яндекс.Каталога, используется для временного снятия с публикации недоступных сайтов в Каталоге"><sub><img src=img/icon_yandex.png width="18"></sub> YandexCatalog </div>',
        ),
		array(
            'YandexBlogs',
			'Yandex',
            '<div class="prosmr" title="Pобот поиска по блогам, индексирующий посты и комментарии"><sub><img src=img/blogs.yandex.png width="18"></sub> YandexBlogs </div>',
        ),
		array(
            'YandexPagechecker',
			'Yandex',
            '<div class="prosmr" title="Bалидатор микроразметки;"><sub><img src=img/icon_yandex.png width="18"></sub> YandexPagechecker </div>',
        ),
		array(
            'YandexDirect',
			'Yandex',
            '<sub><img src=img/icon_yandex.png width="18"></sub> Yandex Direct ',
        ),
		array(
            'YandexMetrika',
			'Yandex',
            '<div class="prosmr" title="Проверяет работоспособность сайта"><sub><img src=img/metrika.png width="18"></sub> YandexMetrika&nbsp;</div>',
        ),
		array(
            'YandexVideo',
			'Yandex',
            '<div class="prosmr" title="Собирает видосы по сайтам"><sub><img src=img/YandexVideo.png width="18"></sub> YandexVideo&nbsp;</div>',
        ),
		array(
            'YandexMedia',
			'Yandex',
            '<sub><img src=img/icon_yandex.png width="18"></sub> YandexMedia ',
        ),
		array(
            'YandexFavicons',
			'Yandex',
            '<div class="prosmr" title="Собирает иконки по сайтам"><sub><img src=img/icon_yandex.png width="18"></sub> YandexFavicons&nbsp;</div>',
        ),
		array(
            'YandexWebmaster',
			'Yandex',
            '<sub><img src=img/icon_yandex.png width="18"></sub> YandexWebmaster ',
        ),
		array(
            'YandexAntivirus',
			'Yandex',
            '<div class="prosmr" title="Сканирует сайты на вири"><sub><img src=img/YandexAntivirus.png width="18"></sub> YandexAntivirus&nbsp;</div>',
        ),
		array(
            'Yandex',
			'Yandex',
            '<sub><img src=img/icon_yandex.png width="18"></sub> Yandex ',
        ),
		array(
            'Adsbot-Google',
			'Google',
            '<div class="prosmr" title="Сканирующий робот от Adwords"><sub><img src=img/google_favicon_64.png width="18"></sub> Adsbot-Google&nbsp;</div>',
        ),
		array(
            'Googlebot-Image',
			'Google',
            '<div class="prosmr" title="Робот Гугла, собирающий картинки"><sub><img src=img/google_favicon_64.png width="18"></sub> Googlebot-Image&nbsp;</div>',
        ),
		array(
            'Googlebot',
			'Google',
            '<div class="prosmr" title="Основной индексирующий робот Гугла"><sub><img src=img/google_favicon_64.png width="18"></sub> Googlebot&nbsp;</div>',
        ),
		array(
            'Googlebot-Mobile',
			'Google',
            '<div><sub><img src=img/google_favicon_64.png width="18"></sub> Googlebot-Mobile</div> ',
        ),
		array(
            'Mediapartners-Google',
			'Google',
            '<sub><img src=img/google_favicon_64.png width="18"></sub> Mediapartners-Google (Adsense) ',
        ),
		array(
            'Google',
			'Google',
            '<sub><img src=img/google_favicon_64.png width="18"></sub> Google ',
        ),
		array(
            'Slurp',
			'Hot Bot search',
            '<sub><img src=img/logo_hotbot.png width="18"></sub> Hot Bot search ',
        ),
		array(
            'WebCrawler',
			'WebCrawler search',
            '<sub><img src=img/web-crawler-spider.png width="18"></sub> WebCrawler search ',
        ),
		array(
            'ZyBorg',
			'Wisenut search',
            '<sub><img src=img/wisenut.gif width="18"></sub> Wisenut search ',
        ),
		array(
            'Scooter',
			'AltaVista',
            '<sub><img src=img/logo_altavista.png width="18"></sub> AltaVista ',
        ),
		array(
            'StackRambler',
			'Rambler',
            '<sub><img src=img/rambler.png width="18"></sub> Rambler ',
        ),
		array(
            'Aport',
			'Aport',
            '<sub><img src=img/logo-mini.png width="18"></sub> Aport ',
        ),
		array(
            'lycos',
			'lycos',
            '<sub><img src=img/lycos_the_dog.png width="18"> Lycos ',
        ),
		array(
            'Yahoo',
			'Yahoo',
            '<sub><img src=img/yahoo.png width="18"></sub> Yahoo ',
        ),
		array(
            'WebAlta',
			'WebAlta',
            '<sub><img src=img/webalta.png height="18"></sub> WebAlta ',
        ),
		array(
            'ia_archiver',
			'Alexa search engine',
            '<sub><img src=img/AlexaRank-Checker.png width="18"></sub> Alexa search engine ',
        ),
		array(
            'FAST',
			'AllTheWeb',
            '<sub><img src=img/yahoo.png width="18"></sub> AllTheWeb ',
        ),
		array(
            'Mail.RU_Bot',
			'Mail',
            '<sub><img title="Основной индексирующий робот" src=img/mail_ru.gif width="18"></sub> Mail ',
        ),
		array(
            'rv:1.9.2.16',
			'Mail Law',
            '<sub><img title="Робот проверяющий права" src=img/mail_ru.gif width="18"></sub> Mail Law ',
        ),
		array(
            'istella.it',
			'istella',
            '<div class="prosmr" title="Поисковой робот"><sub><img src=img/f.png width="18"></sub> istella </div>',
        ),
		array(
            'Nigma.ru',
			'Nigma',
            '<div class="prosmr" title="Поисковой робот"><sub><img src=img/Nigma.png width="18"></sub> Nigma </div>',
        ),
		array(
            'Exabot',
			'Exabot',
            '<sub><img src=img/Exabot.jpg width="18"></sub> Exabot ',
        ),
		array(
            'Baiduspider',
			'Baiduspider',
            '<sub><img title="Индексирующий робот японского поисковика www.baidu.com" src=img/Baidu-icon.png width="18"></sub> Baiduspider ',
        ),
		array(
            'EasouSpider',
			'EasouSpider',
            '<sub><img title="Индексирующий робот поисковика www.easou.com" src=img/easou.png width="18"></sub> EasouSpider ',
        ),
		array(
            'sogou.com',
			'Sogou',
            '<sub><img title="Индексирующий робот поисковика sogou.com" src=img/sogou.png width="18"></sub> Sogou ',
        )
    );
    foreach ($user_bot as $index => $value) {
        if (mb_ereg($value[0], $user_agent_bots)) {
			if(!empty($q_mod)){
            return $value[1];
			}else{
			return $value[2];
			}
        }
    }
    return 'Unknown';
}
?>
<?php
// Функция определения и расшифровки поисковых запросов
function getQ($referer, $q_mod = false, $q_text = false,$img = false){
    $array = array(
        array(
            'yandex.',
            'text=',
            '<sub><img src="img/icon_yandex.png" width="18" ></sub> Yandex',
            'Yandex'
        ),
		array(
            'google.',
            'q=',
            '<sub><img src="img/google.png" width="18" ></sub> Google',
            'Google'
        ),
        array(
            'ask.com',
            'q=',
            '<sub><img src="img/ask.png" width="18" ></sub> ASK',
            'ASK'
        ),
        array(
            'yahoo.com',
            'p=',
            '<sub><img src="img/yahoo.png" width="18" ></sub> Yahoo',
            'Yahoo'
        ),
        array(
            'nigma.ru',
            's=',
            '<sub><img src="img/Nigma.png" width="18" ></sub> Nigma',
            'Nigma'
        ),
        array(
            'maps.yandex.',
            'text=',
            '<sub><img src="img/ru.yandex.yandexmaps.png" width="18" ></sub> Yandex maps',
            'Yandex maps'
        ),
        array(
            'images.yandex.',
            'text=',
            '<sub><img src="img/images_yandex.png" width="18" ></sub> Yandex images',
            'Yandex images'
        ),
        array(
            'market.yandex.',
            'text=',
            '<sub><img src="img/YandexMarket_logo.png" width="18" ></sub> Yandex market',
            'Yandex market'
        ),
        array(
            'yandex.ru/video/',
            'text=',
            '<sub><img src="img/YandexVideo.png" width="18" ></sub> Yandex video',
            'Yandex video'
        ),
        array(
            'yandex.com/video/',
            'text=',
            '<sub><img src="img/YandexVideo.png" width="18" ></sub> Yandex video',
            'Yandex video'
        ),
        array(
            'yandex.by/video/',
            'text=',
            '<sub><img src="img/YandexVideo.png" width="18" ></sub> Yandex video',
            'Yandex video'
        ),
        array(
            'yandex.kz/video/',
            'text=',
            '<sub><img src="img/YandexVideo.png" width="18" ></sub> Yandex video',
            'Yandex video'
        ),
        array(
            'yandex.ua/video/',
            'text=',
            '<sub><img src="img/YandexVideo.png" width="18" ></sub> Yandex video',
            'Yandex video'
        ),
        array(
            'webalta.ru',
            'q=',
            '<sub><img src="img/webalta.png" width="18" ></sub>Webalta',
            'Webalta'
        ),
        array(
            'bing.com',
            'q=',
            '<sub><img src="img/bing.png" width="18" ></sub>Bing',
            'Bing'
        ),
        array(
            'buenosearch.',
            'q=',
            '<sub><img src="img/buenosearch.png" width="18" ></sub> BuenoSearch',
            'BuenoSearch'
        ),
        array(
            'exalead.com',
            'q=',
            '<sub><img src="img/Exabot.jpg" width="18" ></sub>Exalead',
            'Exalead'
        ),
        array(
            'rambler.ru',
            'query=',
            '<sub><img src="img/rambler.png" width="18" ></sub>Rambler',
            'Rambler'
        ),
        array(
            'http://mail.ru',
            'q=',
            '<sub><img src="img/mail_ru.gif" width="18" ></sub>Mail',
            'Mail'
        ),
        array(
            'go.mail.ru',
            'q=',
            '<sub><img src="img/mail_ru.gif" width="18" ></sub>Mail',
            'Mail'
        ),
        array(
            'baidu.com',
            'wd=',
            '<sub><img src="img/Baidu-icon.png" width="18" ></sub>Baidu',
            'Baidu'
        ),
        array(
            'easou.com',
            'q=',
            '<sub><img src="img/easou.png" width="18" ></sub>Easou',
            'Easou'
        ),
        array(
            'sogou.com',
            'query=',
            '<sub><img src="img/sogou.png" width="18" ></sub>Sogou',
            'Sogou'
        ),
        array(
            'dogpile.com',
            'q=',
            '<sub><img src="img/dogpile.png" width="18" ></sub>Dogpile',
            'Dogpile'
        ),
        array(
            'beaucoup.com',
            'q=',
            '<sub><img src="img/beaucoup.png" width="18" ></sub>Beaucoup',
            'Beaucoup'
        ),
        array(
            'allonesearch.com',
            'find=',
            '<sub><img src="img/Allonesearch.png width="18" ></sub>Allonesearch',
            'Allonesearch'
        ),
        array(
            'meta.ua',
            'q=',
            '<sub><img src="img/meta.gif" width="18" ></sub>Meta',
            'Meta'
        ),
        array(
            'list.mail.ru',
            'q=',
            '<sub><img src="img/search.list.mail.png" width="18" ></sub>Каталог Mail',
            'Каталог Mail'
        ),
        array(
            'lycos.com',
            'q=',
            '<sub><img src="img/lycos_the_dog.png" width="18" ></sub>Lycos',
            'Lycos'
        ),
        array(
            'astalavista.box.sk',
            'srch=',
            '<sub><img src="img/Astalavista.png" width="18" ></sub>Astalavista',
            'Astalavista'
        ),
        array(
            'excite.com',
            'q=',
            '<sub><img src="img/excite.gif" width="18" ></sub>Excite',
            'Excite'
        ),
        array(
            'filez.com',
            'q=',
            '<sub><img src="img/filez.png" width="18" ></sub>Filez',
            'Filez'
        ),
        array(
            'hotbot.com',
            'q=',
            '<sub><img src="img/logo_hotbot.png" width="18" ></sub>HotBot',
            'HotBot'
        )
    );
    if ($q_mod) {
        foreach ($array as $value) {
            if (stristr($referer, $value[0])) {
				if(!empty($img)){
					$crawler = $value[2];
				}else{
					$crawler = $value[3];
				}
            }
        }
        return $crawler;
    } else {
        foreach ($array as $value) {
            if (stristr($referer, $value[0])) {
                $search  = $value[1];
                $crawler = $value[2];
                // Расшифровка запроса
                mb_ereg($search . '([^&]*)', $referer . '&', $phrase2);
                if (stristr($phrase2[1], '%F')) {
                    $phrase2 = iconv("CP1251", "UTF-8", urldecode($phrase2[1]));
                } else {
                    $phrase2 = urldecode($phrase2[1]);
                }
            }
        }
        
        if (stristr($phrase2, '√') or stristr($phrase2, 'Є') or stristr($phrase2, 'ї') or stristr($phrase2, 'Ў') or stristr($phrase2, 'Ё') or stristr($phrase2, 'є')) {
            $phrase2 = iconv('CP1251', 'UTF-8', iconv('UTF-8', 'CP866', $phrase2));
        } else if (stristr($phrase2, '░')) {
            $phrase2 = iconv('UTF-8', 'UTF-8', iconv('UTF-8', 'CP866', $phrase2));
        }
        if ($crawler != '' and $phrase2 == '') {
            if ($q_text == true) {
                return 'Не определился';
            } else {
                return $crawler . ': <i style="color: #FFA300;">Не определился</i>' . $phrase2;
            }
        }
        if ($crawler != '' and $phrase2 != '') {
            if ($q_text) {
                return $phrase2;
            } else {
                return $crawler . ': <i style="color: #FFA300;">' . $phrase2 . '</i>';
            }
        }
    }
}
?>
<?php
// Функция конвертации байт
function Size2Str($size){
    $kb = 1024;
    $mb = 1024 * $kb;
    $gb = 1024 * $mb;
    $tb = 1024 * $gb;
    
    if ($size < $kb) {
        return $size . ' байт';
    } else if ($size < $mb) {
        return round($size / $kb, 2) . ' Кб';
    } else if ($size < $gb) {
        return round($size / $mb, 2) . ' Мб';
    } else if ($size < $tb) {
        return round($size / $gb, 2) . ' Гб';
    } else {
        return round($size / $tb, 2) . ' Тб';
    }
}
?>
<?php
function file_put_user($filename, $content){
    if (!file_exists($filename)) {
        $content = "<?php" . PHP_EOL . $content;
    }
    $f = fopen($filename, 'a+');
    fwrite($f, $content . PHP_EOL);
    fclose($f);
    
}
?>
<?php
// Функция обрезки текста
function cut_text($text, $number){
    if (strlen($text) > $number) {
        return substr($text, 0, $number) . '...';
    } else {
        return $text;
    }
}
?>
<?php
function time_user($ip, $CountIP){
    mb_ereg($ip . '_start=' . "([^&]*)", $CountIP . "&", $start);
    mb_ereg($ip . '_end=' . "([^&]*)", $CountIP . "&", $end);
    return date("H:i:s", ($end[1] - $start[1] - 3 * 60 * 60));
}
?>
<?php
function array_count($array){
    $array = array_filter($array);
    $array = array_count_values($array);
    return $array;
}
?>
<?php
function display_stata($stata,$mod,$parametr,$CountIP){
	if($stata[$mod]){
		foreach($stata[$mod] as $value => $i){
			$time = $value;
			$output .= '<div class="_list">';
			foreach($stata[$mod][$value] as $value=>$i){
				if($value=='hostname' and $mod == 'othbot'){
					$hostname = $i;
					$output .= '<span class="_'.$value.'">';
					$output .= '<i>'.getOTHBOTdomain($i).'</i>';
					$output .= '</span>';
				 }
				if($value=='ip'){
					if(in_array("time", $parametr)){
						$output .= '<span class="_time">';
						$output .= '<b>'.date('h:i', $time).'</b>';
						$output .= '</span>';
					}
					if(in_array("count", $parametr)){
						str_replace($i,"",$CountIP,$mas);
						$output .= ', <span class="_'.$value.'_count _wtf prosmr" title="Количество посещений за сегодня">';
						$output .= '('.($mas - 1).')';
						$output .= '</span>';
					}
					if(in_array("time_user", $parametr)){
						$output .= '<span class="_'.$value.'_time _wtf prosmr" title="Время, которое пользователь провел на сайте (Вычесляется из первого посещения и последнего).">';
						$output .= ', Время: <i>'.time_user($i,$CountIP).'</i>';
						$output .= '</span>';
					}
					$output .= '<span class="_'.$value.'">';
					$output .= ', IP: <i>'.$i.'</i>';
					$output .= '</span>';
				}
				if(in_array("city", $parametr) and $value=='city'){
					$output .= '<span class="_'.$value.' _wtf prosmr" title="Город, который определился исходя из IP">';
					$output .= ', Город:<i>'.$i.'</i>';
					$output .= '</span>';
				}
				if(in_array("lon_lat", $parametr) and $value=='lon_lat'){
					$output .= '<span class="_'.$value.' _loop">';
					$output .= '<a data-coords="'.$i.'"><sub><img src="img/lupa.png" width="18"></sub></a>';
					$output .= '</span>';
				}
				if(in_array("request_url", $parametr) and $value=='request_url'){
					$output .= '<div style="clear:both"></div>';
					$output .= '<span class="_'.$value.'">';
					$output .= 'Адрес страницы:';
					$output .= '<a target="_blank" hrea="'.$i.'" href="//'.$i.'">'.cut_text($i,53).'</a>';
					$output .= '</span>';
					$output .= '<div style="clear:both"></div>';
				}
				if(in_array("referer", $parametr) and $value=='referer'){
					$q_search = getQ($i,false);
					if(!empty($q_search)){
						$output .= '<span class="_'.$value.'_q_search">';
						$output .= 'По запросу: '.$q_search;
						$output .= '</span>';
						$output .= '<div style="clear:both"></div>';
					}
					$output .= '<span class="_<?php echo $value;?>">';
					$output .= 'Переход с сайта: <a target="_blank" hrea="'.$i.'" href="'.$i.'">'.cut_text($i,53).'</a>';
					$output .= '</span>';
					$output .= '<div style="clear:both"></div>';
				}
				if(in_array("country", $parametr) and $value=='country'){
					$output .= '<span class="_'.$value.'">';
					$output .= getCOUNTRY($i);
					$output .= ' </span>';
				}
				if(in_array("user_agent", $parametr) and $value=='user_agent'){
					if($mod == 'othbot'){
						$output .= '<span class="_'.$value.'_browser">';
						$output .= getOTHBOT($i);
						$output .= '</span>';
					}elseif($mod == 'bot'){
						$output .= '<span class="_'.$value.'_browser">';
						$output .= getBOT($i);
						$output .= '</span>';
					}else{
						$output .= '<span class="_'.$value.'_browser">';
						$output .= 'Браузер: '.getBROWSER($i);
						$output .= '</span>';
						$output .= '<span class="_'.$value.'_os">';
						$output .= ' OS: '.getOS($i);
						$output .= '</span>';
					}
				}
			}
		$output .= '</div>';
		}
	return $output;
	}else{
	echo '<div class="_no_data">Нет данных</div>';
	}
}
?>
<?php
function head_stata($stata,$mod){
	if($stata[$mod]){
		foreach($stata[$mod] as $value => $i){
			$array[] = getQ($stata[$mod][$value]['referer'],true,true,true);
		}
		$array = array_count($array);
		arsort($array);
		foreach(array_slice($array, 0, 5) as $value => $i){
		$output .= $value.' '.$i.', ';
		}
	return $output;
	}
}
?>