<?php
ini_set('display_errors', 1);
include('../helper.php');
?>
<link rel="stylesheet" type="text/css" href="../css/tracking.css">
<style>
body {
margin: 0;
width: 600px!important;
}
</style>
<script src="../js/amcharts.js" type="text/javascript"></script>
<script src="../js/pie.js" type="text/javascript"></script>
<script src="../js/serial.js" type="text/javascript"></script>
<script src="../js/dark.js" type="text/javascript"></script>
<?php
if ($auth->isAuth()){
$files_user = glob(STATE_PATCH . '/use_*.php');
if(!empty($files_user)){
foreach ($files_user as $i => $value){
	if($diagramm_time=='all'){
		include($files_user[$i]);
	}else{
	include(FILE_USER);
	}
}
foreach ($stata['user'] as $value => $i){
	foreach ($stata['user'][$value]as $value => $i){
		if($value == 'referer'){
		$new_array[] = getQ($i,true);
		}
	}
}
unset($stata);
}
if(!empty($new_array) and !empty($files_user)){
$array_search = array_count_values(array_filter($new_array));
?>
<script type="text/javascript">
var chart;
var legend;

var chartData2 = [
<?php
foreach ($array_search as $i => $value){
	echo  '{"country": "'.$i.'","value":'.$value.' },';
}
?>
];

AmCharts.ready(function () {
    // PIE CHART
    chart = new AmCharts.AmPieChart();
    chart.dataProvider = chartData2;
    chart.titleField = "country";
    chart.valueField = "value";
    chart.outlineColor = "#FFFFFF";
    chart.outlineAlpha = 0.8;
    chart.outlineThickness = 2;
    chart.balloonText = "[[title]]<br><span style='font-size:14px'><b>[[value]]</b> ([[percents]]%)</span>";
    // this makes the chart 3D
    chart.depth3D = 15;
    chart.angle = 30;
    
    // WRITE
    chart.write("charertdiv");
});

</script>
<?php if($diagramm == 'on'){?>
<div id="day">
<?php if($diagramm_time=='all'){?>
Диаграмма популярности поисковиков за <?php echo count($files_user);?> суток.
<?php }else{ ?>
Диаграмма популярности поисковиков за сегодня.
<?php }?>
</div>
<div id="charertdiv" style="width: 600px; height: 270px;"></div>
<?php }?>
<?php }else{?>
<div class="_no_data">Нет данных</div>
<?php }?>
<?php }else{?>
<div class="_no_data">Нет доступа</div>
<?php }?>